(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('rxjs'), require('@angular/router'), require('rxjs/operators')) :
    typeof define === 'function' && define.amd ? define('@microfrontendly/angular-element-routing', ['exports', '@angular/core', '@angular/common', 'rxjs', '@angular/router', 'rxjs/operators'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.microfrontendly = global.microfrontendly || {}, global.microfrontendly['angular-element-routing'] = {}), global.ng.core, global.ng.common, global.rxjs, global.ng.router, global.rxjs.operators));
}(this, (function (exports, core, common, rxjs, router, operators) { 'use strict';

    var MICRO_APP_NAME = new core.InjectionToken('microAppName');
    var ROUTE_CHANGE_EVENT_NAME = new core.InjectionToken('routeChangeEventName');
    var AngularElementRoutingService = /** @class */ (function () {
        function AngularElementRoutingService(microApp, routeChangeEvent, router, location) {
            var _this = this;
            this.microApp = microApp;
            this.router = router;
            this.location = location;
            this.routeChange$ = rxjs.fromEvent(document, routeChangeEvent).pipe(operators.map(function (event) { return event.detail.route; }), operators.filter(function (event) { return event.app === _this.microApp; }));
        }
        AngularElementRoutingService.prototype.initRouting = function () {
            var _this = this;
            this.routeChange$.subscribe(function (event) {
                _this.router.navigateByUrl("" + event.path);
            });
            this.router.navigateByUrl(this.location.path(true));
        };
        return AngularElementRoutingService;
    }());
    AngularElementRoutingService.decorators = [
        { type: core.Injectable }
    ];
    AngularElementRoutingService.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: core.Inject, args: [MICRO_APP_NAME,] }] },
        { type: undefined, decorators: [{ type: core.Inject, args: [ROUTE_CHANGE_EVENT_NAME,] }] },
        { type: router.Router },
        { type: common.Location }
    ]; };

    var AngularElementRouteModule = /** @class */ (function () {
        function AngularElementRouteModule(microRoutingService) {
            this.microRoutingService = microRoutingService;
            microRoutingService.initRouting();
        }
        AngularElementRouteModule.forRoot = function (microElementApplication, routeChangeEventName) {
            return {
                ngModule: AngularElementRouteModule,
                providers: [
                    AngularElementRoutingService,
                    { provide: MICRO_APP_NAME, useValue: microElementApplication },
                    { provide: ROUTE_CHANGE_EVENT_NAME, useValue: routeChangeEventName },
                ],
            };
        };
        return AngularElementRouteModule;
    }());
    AngularElementRouteModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [],
                    imports: [common.CommonModule],
                },] }
    ];
    AngularElementRouteModule.ctorParameters = function () { return [
        { type: AngularElementRoutingService }
    ]; };

    /*
     * Public API Surface of angular-element-routing
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.AngularElementRouteModule = AngularElementRouteModule;
    exports.ɵa = MICRO_APP_NAME;
    exports.ɵb = ROUTE_CHANGE_EVENT_NAME;
    exports.ɵc = AngularElementRoutingService;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=microfrontendly-angular-element-routing.umd.js.map
